package com.fjhx.victoriatourist.service.jd.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.fjhx.victoriatourist.entity.jd.dto.JdOrderSelectDto;
import com.fjhx.victoriatourist.entity.jd.po.JdOrderDetails;
import com.fjhx.victoriatourist.entity.jd.vo.JdOrderDetailsVo;
import com.fjhx.victoriatourist.mapper.jd.JdOrderDetailsMapper;
import com.fjhx.victoriatourist.service.jd.JdOrderDetailsService;
import org.springframework.stereotype.Service;

import java.util.List;


/**
 * <p>
 * 京东订单明细 服务实现类
 * </p>
 *
 * @author 
 * @since 2023-04-20
 */
@Service
public class JdOrderDetailsServiceImpl extends ServiceImpl<JdOrderDetailsMapper, JdOrderDetails> implements JdOrderDetailsService {

    @Override
    public List<JdOrderDetailsVo> findListByJdOrderId(Long jdOrderId) {
        List<JdOrderDetails> list = lambdaQuery().eq(JdOrderDetails::getJdOrderId, jdOrderId).list();
        return BeanUtil.copyToList(list, JdOrderDetailsVo.class);
    }

    @Override
    public Page<JdOrderDetailsVo> jdOrderDetailExList(JdOrderSelectDto dto) {
        Page<JdOrderDetails> page = lambdaQuery()
                .eq(JdOrderDetails::getHasEx, "1")
                .like(ObjectUtil.isNotNull(dto.getOrderId()), JdOrderDetails::getOrderId, dto.getOrderId())
                .eq(StrUtil.isNotBlank(dto.getHandleStatus()), JdOrderDetails::getHandleStatus, dto.getHandleStatus())
                .eq(StrUtil.isNotBlank(dto.getExHandle()), JdOrderDetails::getExHandle, dto.getExHandle())
                .page(new Page<>(dto.getPageNum(), dto.getPageSize()));

        List<JdOrderDetails> records = page.getRecords();
        List<JdOrderDetailsVo> voList = BeanUtil.copyToList(records, JdOrderDetailsVo.class);
        Page<JdOrderDetailsVo> voPage = BeanUtil.copyProperties(page, Page.class);
        voPage.setRecords(voList);

        return voPage;
    }
}
